<?php
/*
	JoomlaXTC Administrator Lock plugin

	version 1.0.0
	
	Copyright (C) 2011  Monev Software LLC.	All Rights Reserved.
	
	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
	
	THIS LICENSE IS NOT EXTENSIVE TO ACCOMPANYING FILES UNLESS NOTED.

	See COPYRIGHT.php for more information.
	See LICENSE.php for more information.
	
	Monev Software LLC
	www.joomlaxtc.com
*/

defined( '_JEXEC' ) or die;

jimport( 'joomla.plugin.plugin' );

class plgSystemjxtcadminlock extends JPlugin {

	function onAfterDispatch() {
		$mainframe =& JFactory::getApplication('admin');

		if (!$mainframe->isAdmin()) { 	// only for admin area
			return;
		}

		$option	= JRequest::getCmd('option');
		$user = &JFactory::getUser();

		$llave = trim($this->params->get('llave'));
		$permisos = str_replace(array("\n","\r"),'',$this->params->get('permisos'));

		if (!empty($llave) && $user->guest) {
			if ($llave != $_SERVER['QUERY_STRING']) {
				$mainframe->redirect(JURI::root());
			}
		}
		
		if (!empty($permisos) && !$user->guest) {
			$grupos = explode(';',$permisos);
			foreach ($grupos as $grupo) {
				@list($userid,$componentes)=explode('=',$grupo,2);
				$options[trim($userid)]=array_map('trim',explode(',',$componentes));
				$options[trim($userid)][]='com_cpanel';
			}
			if (!array_key_exists($user->id,$options)) {
				$options[$user->id][]='com_cpanel'; // at least admin panel should be available
			}
	
			if (!in_array('*',$options[$user->id]) && !in_array($option,$options[$user->id])) {
				$mainframe->redirect( 'index.php', JText::_('ALERTNOTAUTH') );
			}
		}
	}
}